Index: src/backend/commands/proclang.c
===================================================================
RCS file: /home/jeremyd/local/postgres/cvsuproot/pgsql/src/backend/commands/proclang.c,v
retrieving revision 1.71
diff -c -r1.71 proclang.c
*** src/backend/commands/proclang.c	22 Jan 2007 01:35:20 -0000	1.71
--- src/backend/commands/proclang.c	24 Jan 2007 23:50:49 -0000
***************
*** 61,74 ****
  	Oid			funcargtypes[1];
  
  	/*
- 	 * Check permission
- 	 */
- 	if (!superuser())
- 		ereport(ERROR,
- 				(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
- 				 errmsg("must be superuser to create procedural language")));
- 
- 	/*
  	 * Translate the language name and check that this language doesn't
  	 * already exist
  	 */
--- 61,66 ----
***************
*** 97,102 ****
--- 89,103 ----
  					(errmsg("using pg_pltemplate information instead of CREATE LANGUAGE parameters")));
  
  		/*
+ 		 * Check permission
+ 		 */
+ 		if (!pltemplate->tmpltrusted && !superuser())
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
+ 					 errmsg("must be superuser to create untrusted procedural language")));
+ 
+ 
+ 		/*
  		 * Find or create the handler function, which we force to be in the
  		 * pg_catalog schema.  If already present, it must have the correct
  		 * return type.
***************
*** 189,194 ****
--- 190,203 ----
  					 errhint("The supported languages are listed in the pg_pltemplate system catalog.")));
  
  		/*
+ 		 * Check permission
+ 		 */
+ 		if (!superuser())
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
+ 					 errmsg("must be superuser to create custom procedural language")));
+ 
+ 		/*
  		 * Lookup the PL handler function and check that it is of the expected
  		 * return type
  		 */
